/*
** displaylist.c - ǥץ쥤ꥹ
*/

#include <GL/glut.h>
#include <math.h>
#include "laconia.h"
#include "oglportable.h"

/* ǥץ쥤ꥹѤŪѿ */
static GLuint index;

/* 褹ǥץ쥤ꥹȤ */
void
createMountainList( float size )
{
  int i, j, k;
  double angle;
  float radius, x, y, z;

  /* ǥץ쥤ꥹ̾ */
  index = glGenLists( 1 );

  /* ǥץ쥤ꥹȺ */
  glNewList( index, GL_COMPILE_AND_EXECUTE );

  for( i=0; i<6; i++ )
  {
    glBegin(GL_QUAD_STRIP);
    for( j=0; j<37; j++ )
    {
      angle = 2.0*M_PI*(double)j/36.0;
      for( k=0; k<2; k++ )
      {
        radius = size*(float)(5+k-i)/6.0;

        x = radius*(float)cos(angle);
        y = (1.0+(float)cos(M_PI*(double)(radius/size)))*size/2.0;
        z = -radius*(float)sin(angle);
        glVertex3f(x, y, z);
      }
    }
    glEnd();
  }

  /* ǥץ쥤ꥹȺλ */
  glEndList();

  return;
}

void
initialize(void)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  glEnable( GL_DEPTH_TEST );
  glEnable( GL_CULL_FACE );

  /* ǥץ쥤ꥹȤ */
  createMountainList( 20.0f );
}

void
display(void)
{
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glPushMatrix();
  glColor3f( 1.0f, 1.0f, 0.0f );

  /* ǥץ쥤ꥹȤ */
  glCallList( index );

  glPopMatrix();

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
