/*
 * font-stroke.c GLUTΥȥեȤȤץ
 */
#include <GL/glut.h>
#include "font.h"

void
initialize(void)
{
    glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
}

void
drawStrokeString(GLfloat x, GLfloat y, float xscl, float yscl, 
		 void *font, char *string)
{
    glPushMatrix();
    glTranslatef(x, y, 0.0f);
    glScalef(xscl, yscl, 1.0f);

    /* ȥեʸ */    
    while (*string)
	glutStrokeCharacter(font, *string++);
    
    glPopMatrix();
}

void
display(void)
{
    glClear(GL_COLOR_BUFFER_BIT);
    glColor3f(0.0f, 0.0f, 0.0f);

    drawStrokeString(5.0f, 280.0f, 0.15f, 0.15f,
      GLUT_STROKE_ROMAN, 
      "Propotional 0123456 abcdefg ABCDEFG"); 

    drawStrokeString(5.0f, 240.0f, 0.12f, 0.12f,
      GLUT_STROKE_ROMAN, 
      "Propotional 0123456 abcdefg ABCDEFG"); 

    drawStrokeString(5.0f, 180.0f, 0.15f, 0.15f,
      GLUT_STROKE_MONO_ROMAN,
      "Mono 0123456 abcdefg ABCDEFG"); 

    drawStrokeString(5.0f, 140.0f, 0.12f, 0.15f,
      GLUT_STROKE_MONO_ROMAN,
      "Mono 0123456 abcdefg ABCDEFG"); 

    drawStrokeString(5.0f, 100.0f, 0.10f, 0.10f,
      GLUT_STROKE_MONO_ROMAN,
      "Mono 0123456 abcdefg ABCDEFG"); 

    drawStrokeString(70.0f, 25.0f, 0.1f, 0.1f,
      GLUT_STROKE_ROMAN,
      "OpenGL(TM) is a registered trademark");
    drawStrokeString(70.0f,  5.0f, 0.1f, 0.1f,
      GLUT_STROKE_ROMAN,
      "of Silicon Graphics, Inc.");

    glFlush();
}

void
keyboard(unsigned char key, int x, int y)
{
    const unsigned char ESCAPE_KEY = 0x1B;
    if (key == ESCAPE_KEY) exit(0);
}

void
reshape(int width, int height)
{
    glViewport(0, 0, width, height);
    glLoadIdentity();
    glOrtho(0.0, (GLdouble)width, 0.0, (GLdouble)height, 0.0, 1.0);
}

int
main(int argc, char* argv[])
{
    glutInitDisplayMode( GLUT_SINGLE | GLUT_RGB );
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( 500, 300 );
    glutCreateWindow( argv[0] );

    glutReshapeFunc( reshape );
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );

    initialize();
    glutMainLoop();
    return 0;
}
