/*
 * rotate.c
 *
 * workProc Ȥä˥᡼
 *
 *                         GLwMDrawingArea
 *                       /
 *     toplevel - XmForm
 *                       \
 *                         XmPushButton
 *
 * cc -o rotate rotate.c -lGLw -lGL -lXm -lXt -lX11
 */
#include <X11/Intrinsic.h>
#include <X11/Xm/Xm.h>
#include <X11/Xm/Form.h>
#include <X11/Xm/PushB.h>
#include <GL/GLwMDrawA.h>
#include <GL/glx.h>

GLfloat angle = 0.0;

Display *dpy;
GLXContext context;

void scene()
{
   GLfloat x, y;
   int i;
   static GLfloat raingow[][3] = {
	{0.933, 0.509, 0.933}, /* violet */
	{0.294, 0.000, 0.509}, /* indigo */
	{0.000, 0.000, 1.000}, /* blue   */
	{0.000, 1.000, 0.000}, /* green  */
	{1.000, 1.000, 0.000}, /* yellow */
	{1.000, 0.647, 0.000}, /* orange */
	{1.000, 0.000, 0.000}, /* red    */
    };

    x = 0.6;
    y = 0.6;
    for (i = 0; i < 6; i++) {
	glBegin(GL_POLYGON);
	  glColor3fv(raingow[i]);
	  glVertex2f(-x, y);
	  glVertex2f( x, y);
	  glColor3fv(raingow[i+1]);
	  glVertex2f( x, y-0.2);
	  glVertex2f(-x, y-0.2);
	glEnd();
	y = y - 0.2;
    }
}

void ginit(Widget w, XtPointer data, XtPointer callData)
{
    glXMakeCurrent(dpy, XtWindow(w), context);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

void drawScene(Widget w, XtPointer data, XtPointer callData)
{
    glXMakeCurrent(dpy, XtWindow(w), context);

    glPushMatrix();

    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClear(GL_COLOR_BUFFER_BIT);

    glRotatef(angle, 0.0, 0.0, 1.0);

    scene();

    glPopMatrix();

    /*
     * åץХåե
     */
    glXSwapBuffers(dpy, XtWindow(w));
}

/*
 * WorkProc
 */
Boolean workProc(XtPointer data)
{
    angle += 0.5; if (angle >= 360.0) angle = 0.0;
    drawScene((Widget)data, NULL, NULL);
    return False;
}

void resize(Widget w, XtPointer data, XtPointer callData)
{
    Dimension width, height;

    /*
     * GLX ƥȤ򥢥å
     */
    glXMakeCurrent(dpy, XtWindow(w), context);

    if (XtIsRealized(w)) {

	/*
	 * Widget ꥢ饤ƤСȹ⤵
	 */
        XtVaGetValues(w, XtNwidth, &width, XtNheight, &height, NULL);

	/*
	 * ӥ塼ݡȤ򹹿
	 */
        glViewport(0, 0, (GLint)width, (GLint)height);
    }
}

void quit(Widget w, XtPointer data, XtPointer callData)
{
    exit(0);
}

int
main(int argc, char *argv[])
{
    Widget toplevel;
    Widget form, pushButton, glx;
    XtAppContext app;
    XVisualInfo *visualInfo;
    Arg args[16];
    Cardinal n;
    Dimension offset;
					/* ֥Хåե */
    static int attributes[] = { GLX_DOUBLEBUFFER,
			GLX_RGBA,
			GLX_RED_SIZE,   1,
			GLX_GREEN_SIZE, 1,
			GLX_BLUE_SIZE,  1,
			None };
    static String fallbackResources[] = {
	"*geometry: 300x200+100+100",
	"*foreground: black",
	"*background: PaleGreen",
	"*fontList: -adobe-helvetica-*--14-*",
	NULL
    };

    XtSetLanguageProc(NULL, NULL, NULL);

    toplevel = XtAppInitialize(&app, "XmSample", NULL, 0, &argc, argv,
			fallbackResources, NULL, 0);
    dpy = XtDisplay(toplevel);

   /*
    * GLX ĥݡȤƤ뤫ǧ
    */
    if (glXQueryExtension(dpy, NULL, NULL) == NULL) exit(1);

    form = XtCreateManagedWidget("form", xmFormWidgetClass,
				toplevel, NULL, 0);
    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightOffset, 5); n++;
    XtSetArg(args[n], XmNbottomOffset, 5); n++;
    XtSetArg(args[n], XmNlabelString,
		XmStringCreate("Quit", XmSTRING_DEFAULT_CHARSET)); n++;
    pushButton = XtCreateManagedWidget("pushButton", xmPushButtonWidgetClass,
				form, args, n);
    XtAddCallback(pushButton, XmNactivateCallback, quit, NULL);

    n = 0;
    XtSetArg(args[n], XtNheight, &offset); n++;
    XtGetValues(pushButton, args, n);
    offset += 10;

    visualInfo = glXChooseVisual(dpy, DefaultScreen(dpy), attributes);
    context = glXCreateContext(dpy, visualInfo, None, GL_TRUE);

    n = 0;
    XtSetArg(args[n], GLwNvisualInfo, visualInfo); n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftOffset, 5); n++;
    XtSetArg(args[n], XmNrightOffset, 5); n++;
    XtSetArg(args[n], XmNtopOffset, 5); n++;
    XtSetArg(args[n], XmNbottomOffset, offset); n++;
    XtSetArg(args[n], XmNtraversalOn, True); n++;
    glx = XtCreateWidget("glx", glwMDrawingAreaWidgetClass,
				form, args, n);

    XtAddCallback(glx, GLwNexposeCallback, drawScene, NULL);
    XtAddCallback(glx, GLwNresizeCallback, resize, NULL);
    XtAddCallback(glx, GLwNginitCallback, ginit, NULL);

    XtManageChild(glx);

    XtRealizeWidget(toplevel);

    /*
     * WorkProc Ͽ
     */
    XtAppAddWorkProc(app, workProc, glx);

    XtAppMainLoop(app);
    return 0;
}
