/*
** saveimage.c - SGI᡼եؤ¸
*/

#include <stdio.h>
#include <GL/glut.h>
#include "laconia.h"
#include "sgiimage.h"

static char *imagefile;

void
initialize(void)
{
    glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
    
    glEnable( GL_DEPTH_TEST );
    glEnable( GL_CULL_FACE );
    
    glEnable( GL_LIGHTING );
    glEnable( GL_LIGHT0 );
    glEnable( GL_NORMALIZE );

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt( 0.0, 50.0, 100.0,
               0.0,  0.0,   0.0,
	       0.0,  1.0,   0.0 );
}

void
saveimage(void)
{
    int width  = glutGet(GLUT_WINDOW_WIDTH);
    int height = glutGet(GLUT_WINDOW_HEIGHT);

    /* ᡼ǡΤΥ꡼ΰ */
    unsigned int *pixels
	= (unsigned int *)malloc(width*height*sizeof(unsigned int));

    /* ե졼Хåե饤᡼ɤ߹ */
    glReadPixels(0, 0, width, height, GL_RGBA, GL_UNSIGNED_BYTE, pixels);

    /* ᡼ե¸ */
    if (rgbWriteImageFile(imagefile, width, height, pixels))
	fprintf(stderr, "Saved: %s\n", imagefile);
    else
	fprintf(stderr, "Unable to save: %s\n", imagefile);
}

void
keyboard( unsigned char c, int x, int y )
{
    /* ESC򲡤Ƚλ"p"򲡤ȥ᡼եΥ */
    if (c == 27) exit(0);
    else if (c == 'P' || c == 'p') saveimage();
}

void
display(void)
{
    static GLfloat ad[] = { 0.0, 1.0, 0.0, 1.0 };
    static GLfloat shininess[] = { 50.0 };
    
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    
    /* ˥ޥƥꥢץѥƥꤹ */
    glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, ad );
    glMaterialfv( GL_FRONT, GL_SHININESS, shininess );
    
    lacMountain( 20.0 );
    glutSwapBuffers();
}

void
reshape( int w, int h )
{
    glViewport( 0, 0, w, h );
    
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
    glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
    glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
    glutInit( &argc, argv );
    
    if (argc != 2)
    {
	fprintf(stderr, "Usage: %s <image-file-name>\n", argv[0]);
	return 1;
    }
    imagefile = argv[1];
    
    glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
    
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( 500, 400 );
    
    /* ˡ򥦥ɥȥɽ */
    glutCreateWindow( "Press p key to save the image" );
    
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );
    glutReshapeFunc( reshape );
    glutIdleFunc( animate );

    initialize();
    glutMainLoop();
    return 0;
}
